
package cz.zcu.kiv.db.dao.jdbc.model;

import cz.zcu.kiv.db.dao.OsobaDao;
import cz.zcu.kiv.db.dao.StudiumDao;
import cz.zcu.kiv.db.dao.TemaDao;
import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.db.model.studium.Obor;
import cz.zcu.kiv.db.model.studium.Tema;
import cz.zcu.kiv.db.model.studium.TypPrace;

/**
 *
 * @author Radek Muzika
 */
public class JdbcTema extends Tema {

    private TemaDao _temaDao;
    private OsobaDao _osobaDao;
    private StudiumDao _studiumDao;
    
    private int fkGarant;
    private int fkTypPrace;
    private int fkObor;
    private boolean garantNeni = false;
    private boolean oborNeni = false;
    private boolean typPraceNeni = false;
    
    
    @Override
    public Osoba getGarant() {
        if(super.getGarant()==null && !garantNeni && fkGarant>0) {
            super.setGarant(_osobaDao.getOsoba(fkGarant));
            if(super.getGarant()==null) garantNeni = true;
        }
        return super.getGarant();
    }

    @Override
    public Obor getObor() {
        if(super.getObor()==null && !oborNeni && fkObor>0) {
            super.setObor(_studiumDao.getObor(fkObor));
            if(super.getObor()==null) oborNeni = true;
        }
        return super.getObor();
    }

    @Override
    public TypPrace getTypPrace() {
        if(super.getTypPrace()==null && !typPraceNeni && fkTypPrace>0) {
            super.setTypPrace(_temaDao.getTypPrace(fkTypPrace));
            if(super.getTypPrace()==null) typPraceNeni = true;
        }
        return super.getTypPrace();
    }

    public void setTemaDao(TemaDao temaDao) {
        this._temaDao = temaDao;
    }

    public int getFkGarant() {
        return fkGarant;
    }

    public void setFkGarant(int fkGarant) {
        this.fkGarant = fkGarant;
    }

    public void setOsobaDao(OsobaDao osobaDao) {
        this._osobaDao = osobaDao;
    }

    public void setStudiumDao(StudiumDao studiumDao) {
        this._studiumDao = studiumDao;
    }

    public int getFkTypPrace() {
        return fkTypPrace;
    }

    public void setFkTypPrace(int fkTypPrace) {
        this.fkTypPrace = fkTypPrace;
    }

    public int getFkObor() {
        return fkObor;
    }

    public void setFkObor(int fkObor) {
        this.fkObor = fkObor;
    }
    
}
